freeslot("S_EBARRELIDLE_SG", "MT_WATERBALL", "MT_WATERPOINT", "MT_SGBEACHBALL", "MT_BOSSPAWNER")

local fadephase = 0
local daytimer = 0
local raintimer = 0
local rainchance = false
rawset(_G, "bosschance", false)

local cv_usefade = CV_RegisterVar({
  name = "sg_usefade",
  defaultvalue = "On",
  possiblevalue = CV_OnOff,
})

local cv_sgtimestop = CV_RegisterVar({
    name = "sg_timestop",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
})

local cv_sgrain = CV_RegisterVar({
    name = "sg_rain",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
})

COM_AddCommand("sg_time", function(player, setting)
    setting = ($ or ""):lower() -- <- makes it case insensetive

    if setting == "dawn" then -- <- make sure to use all lowercase strings
		daytimer = 359*TICRATE
	elseif setting == "noon" then
		daytimer = 599*TICRATE
	elseif setting == "dusk" then
		daytimer = 1019*TICRATE
	elseif setting == "night" then
		daytimer = 1429*TICRATE
	else
		CONS_Printf(player, "Available values: dawn, noon, dusk, night")
	end
end, COM_ADMIN)

COM_AddCommand("sg_weather", function(player, setting)
    setting = ($ or ""):lower() -- <- makes it case insensetive

    if setting == "none" then -- <- make sure to use all lowercase strings
		P_SwitchWeather(0)
		raintimer = 0
	elseif setting == "storm" then
		P_SwitchWeather(1)
	elseif setting == "snow" then
		P_SwitchWeather(2)
	elseif setting == "rain" then
		P_SwitchWeather(3)
	else
		CONS_Printf(player, "Available values: none, storm, snow, rain")
	end
end, COM_ADMIN)

COM_AddCommand("sg_boss", function(player, setting)
    setting = ($ or ""):lower() -- <- makes it case insensetive

    if setting == "madfather" then -- <- make sure to use all lowercase strings
		P_SwitchWeather(3)
		P_LinedefExecute(7556)
		rawset(_G, "bosschance", true)
	else
		CONS_Printf(player, "Available values: madfather")
	end
end, COM_ADMIN)

local cv_waterfloatdebug = CV_RegisterVar({
    name = "waterfloatdebug",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
})

addHook("ThinkFrame", function()
    local rainchance = false
	rawset(_G, "bosschance", false)
	
	if cv_sgtimestop.value == 0 then
		daytimer = $ + 1
	end
	raintimer = max(($ or 0) - 1, 0)

---------- Day Timer
    --Dawn
    if daytimer == 360*TICRATE then
        fadephase = 1
        if raintimer == 0 then
            P_LinedefExecute(7551)
            rainchance = true
        end
    end
    
    --Noon
    if daytimer == 600*TICRATE then
        fadephase = 0
        if raintimer == 0 then
            P_LinedefExecute(7552)
            rainchance = true
        end
    end
    
    --Dusk
    if daytimer == 1020*TICRATE then
        fadephase = 2
        if raintimer == 0 then
            P_LinedefExecute(7553)
            rainchance = true
        end
    end

    --Night
    if daytimer == 1430*TICRATE then
        fadephase = 4
        if raintimer == 0 then
            P_LinedefExecute(7554)
            rainchance = true
        end
    end
    
-------------- Weather
    --Random chance for rain
    if rainchance and P_RandomChance(FRACUNIT/5) and raintimer == 0 or cv_sgrain.value then
        P_LinedefExecute(7561)
		P_SwitchWeather(P_RandomRange(1, 3))
        raintimer = P_RandomRange(499*TICRATE, 742*TICRATE)
    end
	
    --Clear rain
    if raintimer == 1 then
		P_SwitchWeather(0)
        raintimer = 0
    end
    
---------------
    --Day Reset
    if daytimer == 1440*TICRATE then
        daytimer = 0 --The day resets
		raintimer = 0 --Stupid fucking doom shit or something, safeguard to make it stop raining
    end
	
	local playerCount = 0
	for p in players.iterate do
		playerCount = $ + 1
	end

	if daytimer == 1445*TICRATE and P_RandomChance(FRACUNIT/10) and playerCount <= 4 then
		rawset(_G, "bosschance", true)
	end
end)

addHook("MobjSpawn", function(mo)
  if G_BuildMapName(gamemap) ~= "MAPSI" then return end
  mo.scale = mapobjectscale*3
  mo.destscale = mo.scale
end, MT_PALMTREE2)

states[S_EBARRELIDLE_SG] = {
    sprite = SPR_BRRL,
    frame = A,
	duration = -1,
    nextstate = S_NULL,
}

addHook("MobjSpawn", function(mo)
  if G_BuildMapName(gamemap) ~= "MAPSI" then return end
  mo.state = S_EBARRELIDLE_SG
  mo.flags = MF_SOLID
end, MT_EXPLODINGBARREL)

addHook("TouchSpecial", function(mo, toucher)
  mo.momx = 4*toucher.momx
  mo.momy = 4*toucher.momy
  mo.angle = toucher.angle
  P_SetObjectMomZ(mo, 10*FRACUNIT, false) -- <- Bounce upwards
  return true -- <- makes object not disappear
end, MT_SGBEACHBALL)

addHook("MobjThinker", function(mo)
  if not mo.valid then return end

  local onground = P_IsObjectOnGround(mo)

  if onground and not mo.lastonground and mo.lastmomz ~= nil then
    P_SetObjectMomZ(mo, -3*mo.lastmomz/4, true)
    mo.momx = 3*mo.momx/4
    mo.momy = 3*mo.momy/4
  end

  mo.lastmomz = mo.momz
  mo.lastonground = onground
end, MT_SGBEACHBALL)

--addHook("MobjSpawn", function(mo)
--  if G_BuildMapName(gamemap) ~= "MAPSI" then return end
--  mo.flags = $ | MF_ENEMY
--end, MT_BIGTUMBLEWEED)

--addHook("PlayerSpin", function(p, inflictor, source)
--    if G_BuildMapName(gamemap) ~= "MAPSI" then return end
--    if inflictor and inflictor.valid and inflictor.type == MT_BIGTUMBLEWEED then return true end
--end)

freeslot("SPR_SGLS", "S_SG_LIFESAVER", "MT_SG_LIFESAVER")

mobjinfo[MT_SG_LIFESAVER] = {
    spawnstate = S_SG_LIFESAVER,
    flags = MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT,
    dispoffset = 10,
}

function A_SGLifeSaver(mo)
    if not mo.target then
        P_RemoveMobj(mo)
        return
    end

    P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
    mo.spritexscale = mo.target.spritexscale
    mo.spriteyscale = mo.target.spriteyscale
    mo.spritexoffset = mo.target.spritexoffset
    mo.spriteyoffset = mo.target.spriteyoffset
    mo.color = mo.target.color
    mo.scalespeed = mapobjectscale/12
	
    if mo.target.nowaterfloat or (P_IsObjectOnGround(mo.target) and not mo.target.waterfloat) then
		mo.hide = true
	end
	
	if mo.target.waterfloat then
		mo.hide = false
	end

    if mo.hide then
        mo.destscale = mapobjectscale/24

        if mo.scale <= mapobjectscale/24 then
            mo.flags2 = $ | MF2_DONTDRAW
        end
    else
        mo.flags2 = $ & ~MF2_DONTDRAW
        mo.destscale = mapobjectscale/2
    end
end

states[S_SG_LIFESAVER] = {
    sprite = SPR_SGLS,
    frame = A,
    tics = 1,
    nextstate = S_SG_LIFESAVER,
    action = A_SGLifeSaver,
}

-- List of mobjs that this will be applied to
-- thank indev
local MOBJS = { 
	MT_WATERBALL, 
	MT_WATERPOINT, 
	MT_PLAYER, 
	MT_SGBEACHBALL, 
	MT_ORBINAUT, 
	MT_CHAO, 
	MT_BANANA,
	MT_MINE,
	MT_JAWZ,
	MT_SHOTGUN,
	MT_MADFATHER,
	}

-- Maximim raising for when you're underwater
local MAXSPEED = 4*FRACUNIT

-- How quickly "bouncing" should stop?
local DAMPER = FRACUNIT/2

-- How quickly player moves forward in water?
local PLAYER_SWIMSPEED = 2*FRACUNIT/3

-- How quickly player sinks?
local PLAYER_SINKSPEED = 4*FRACUNIT

local waterfof = (FF_EXISTS|FF_SWIMMABLE)

local active = false

local function checkWater(mo)
    local flip = mo.eflags & MFE_VERTICALFLIP

    local watertop = nil

    for rover in mo.subsector.sector.ffloors() do
        if (rover.flags & waterfof) ~= waterfof then continue end
        if (rover.flags & FF_GOOWATER) == FF_GOOWATER then continue end -- Let this do its job

        local top = rover.topheight
        local bottom = rover.bottomheight

        if rover.t_slope then top = P_GetZAt(rover.t_slope, mo.x, mo.y) end
        if rover.b_slope then bottom = P_GetZAt(rover.b_slope, mo.x, mo.y) end

        local motop = mo.z + mo.height
        local mobottom = mo.z

        if not (motop < bottom or mobottom > top) then
            if flip then
                watertop = bottom
            else
                watertop = top
            end

            break
        end
    end

    return watertop
end

local function thinker(mo)
    if not mo.valid then return end
    if not (active or cv_waterfloatdebug.value) then return end
	
	mo.waterfloat = false
	
    if mo.nowaterfloat then return end -- Can be toggled off per mobj

    local flip = mo.eflags & MFE_VERTICALFLIP
    local watertop = checkWater(mo)

    if mo.player then
        mo.player.kartstuff[k_waterskip] = 2
    end
	
	if mo.type == MT_SHOTGUN and mo.state == S_SGSHOTGUNPLAYER then
		return
	end
	
    if mo.lastunderwater ~= nil and mo.lastunderwater ~= 0 and ((mo.eflags & MFE_UNDERWATER) == 0) then
        -- mobj->momz = FixedMul(mobj->momz, FixedDiv(780*FRACUNIT, 457*FRACUNIT)); // Give the mobj a little out-of-water boost.
        mo.momz = FixedMul(mo.momz, FixedDiv(457*FRACUNIT, 780*FRACUNIT)) -- No :Trollic:
    end

    if watertop ~= nil then
        local depth

        if flip then
            depth = max(mo.z+mo.height - watertop, 0)
        else
            depth = max(watertop - mo.z, 0)
        end

        -- Not exactly "force", more like acceleration
        local force = FixedMul(2*FRACUNIT, FixedDiv(depth, mo.height))

        local damper = 0

        if mo.lastforce ~= nil then
            damper = FixedMul(force - mo.lastforce, mo.player and 4*DAMPER or DAMPER)
        end

        P_SetObjectMomZ(mo, min(force + damper, MAXSPEED), true)

        mo.lastforce = force

        if mo.player then
            local cmd = mo.player.cmd

            local forward = 0
            local downward = 0

            if cmd.buttons & BT_ACCELERATE then
                forward = PLAYER_SWIMSPEED
            end

            if cmd.buttons & BT_BRAKE then
                downward = -PLAYER_SINKSPEED
            end

            P_Thrust(mo, mo.angle, forward)
            P_SetObjectMomZ(mo, downward, true)
        end
    end

    mo.lastunderwater = mo.eflags & MFE_UNDERWATER
    mo.waterfloat = watertop ~= nil
end

--Spawn boss
addHook("MobjThinker", function(mo)
    if not mo.valid then return end
	
	mo.bosstimer = max(($ or 0) - 1, 0)

	if bosschance then
		S_StartSound(nil, sfx_madid1)
		local boss = P_SpawnMobj(mo.x, mo.y, mo.z, MT_MADFATHER)
		mo.bosstimer = 800*TICRATE
	end
	
	if mo.bosstimer == 1*TICRATE then
		S_StartSound(nil, sfx_madid3)
		P_RemoveMobj(boss)
		P_LinedefExecute(7552)
	end
end, MT_BOSSPAWNER)

addHook("PlayerThink", function(p)
	if p.spectator then return end
	
	p._lastbtn = p._lastbtn or 0
	if (p.cmd.buttons & BT_CUSTOM2) ~= 0 and p._lastbtn == 0 then
		p.clock_button = 1 - (p.clock_button or 0)
	end
	p._lastbtn = (p.cmd.buttons & BT_CUSTOM2)
	
    if not (active or cv_waterfloatdebug.value) then return end

    if p.cmd.buttons & BT_CUSTOM1 then
        p.waterfloat_button = ($ or 0) + 1
    else
        p.waterfloat_button = 0
    end

    if p.waterfloat_button == 1 then
        p.mo.nowaterfloat = not $
    end

    if not (p.mo.lifesaver and p.mo.lifesaver.valid) then
        local ls = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SG_LIFESAVER)
        ls.target = p.mo
        p.mo.lifesaver = ls
    end
end)

local function formatTime(time)
    return string.format("%d'%02d\"%02d", G_TicsToMinutes(time, true), G_TicsToSeconds(time), G_TicsToCentiseconds(time))
end

hud.add(function(v, p)
	if G_BuildMapName(gamemap) ~= "MAPSI" then return end

	hud.disable("position")
	hud.disable("rankings")
	hud.disable("gametypeinfo")
	hud.disable("freeplay")
	hud.disable("time")
	hud.disable("minirankings")
	
	if cv_usefade.value == 1 then
		v.fadeScreen(31, fadephase)
		
		if globalweather ~= 0 then
			v.fadeScreen(31, fadephase+1)
		end
	end
	
------ Clock
	if not p.clock_button then
		local timeString = formatTime(daytimer)
		local scale = 2

		local x = 320/2 -- Center the text
		local y = 8
		v.drawString(x, y, timeString, V_SNAPTOTOP, "center")
		v.draw(x-52, y, v.cachePatch("SGTIMEH"), V_SNAPTOTOP)
	end
end)

addHook("MapLoad", function(mapid)
    active = mapheaderinfo[mapid].water_float_physics ~= nil
	daytimer = 0
	raintimer = 0
	fadephase = 0
	rainchance = false
	rawset(_G, "bosschance", false)
end)

addHook("NetVars", function(net)
    active = net($)
	daytimer = net(daytimer)
	raintimer = net(raintimer)
	fadephase = net(fadephase)
	rainchance = net(rainchance)
	rawset(_G, "bosschance", net(bosschance))
end)

for _, mt in ipairs(MOBJS) do
    addHook("MobjThinker", thinker, mt)
end
