freeslot("MT_BOWLINGPIN_SPAWNER")

mobjinfo[MT_BOWLINGPIN_SPAWNER] = {
    spawnstate = S_INVISIBLE,
	doomednum = 2913,
    flags = MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOGRAVITY,
}

local function bowling(mo, mo2)
    if not mo.valid and mo2.valid then return end
    if mo.z > mo2.z + mo2.height or mo2.z > mo.z + mo.height then return end
    if ((mo2.type ~= MT_BOWLINGPIN or mo2.state == S_BOWLINGPIN) and mo2.type ~= MT_ORBINAUT) or mo.state ~= S_BOWLINGPIN then return end

    mo.state = S_BOWLINGHIT1
    mo.angle = R_PointToAngle2(0, 0, mo2.momx, mo2.momy)
    mo.radius = 3*mo.radius/2
    P_SetObjectMomZ(mo, 4*FRACUNIT, true)
    P_InstaThrust(mo, mo.angle, 40*FRACUNIT)

    mo2.angle = $ + P_RandomRange(-15, 15)*ANG1
    P_InstaThrust(mo2, mo2.angle, 3*FixedHypot(mo2.momx, mo2.momy)/4)

    return false
end

addHook("MobjCollide", bowling, MT_BOWLINGPIN)
addHook("MobjMoveCollide", bowling, MT_BOWLINGPIN)

addHook("MobjThinker", function(mo)
    if not mo.valid then return end

    if not (mo.target or mo.fuse) then
        mo.fuse = TICRATE
    end
end, MT_BOWLINGPIN_SPAWNER)

addHook("MobjFuse", function(mo)
    mo.target = P_SpawnMobj(mo.x, mo.y, mo.z, MT_BOWLINGPIN)
    mo.target.angle = mo.angle

    return true
end, MT_BOWLINGPIN_SPAWNER)

COM_AddCommand("spawnpins", function(p)
    local x = p.mo.x
    local y = p.mo.y
    local z = p.mo.z

    x = x + P_ReturnThrustX(nil, p.mo.angle, p.mo.radius*2)
    y = y + P_ReturnThrustY(nil, p.mo.angle, p.mo.radius*2)

    local r = mobjinfo[MT_BOWLINGPIN].radius*2

    for i = 1, 4 do
        if i > 1 then
            -- Move forward
            x = x + P_ReturnThrustX(nil, p.mo.angle, 2*r)
            y = y + P_ReturnThrustY(nil, p.mo.angle, 2*r)

            -- Move slightly to side
            x = x + P_ReturnThrustX(nil, p.mo.angle + ANGLE_90, r)
            y = y + P_ReturnThrustY(nil, p.mo.angle + ANGLE_90, r)
        end

        for j = 0, i-1 do
            local spawnx = x + P_ReturnThrustX(nil, p.mo.angle - ANGLE_90, j*2*r)
            local spawny = y + P_ReturnThrustY(nil, p.mo.angle - ANGLE_90, j*2*r)

            local spawn = P_SpawnMobj(spawnx, spawny, z, MT_BOWLINGPIN_SPAWNER)
            spawn.angle = p.mo.angle
        end
    end
end)
