freeslot("MT_SHOTGUN", "MT_SHOTGUNBULLET", "S_SGSHOTGUNPLAYER", "S_SGSHOTGUNGROUND", "SPR_SGPS", "sfx_sgpss")

states[S_SGSHOTGUNPLAYER] = {
    sprite = SPR_SGPS,
    frame = A,
	duration = -1,
    nextstate = S_NULL,
}
states[S_SGSHOTGUNGROUND] = {
    sprite = SPR_SGPS,
    frame = FF_PAPERSPRITE|B,
	duration = -1,
    nextstate = S_NULL,
}

addHook("TouchSpecial", function(mo, toucher)
	if (toucher.player.kartstuff[k_spinouttimer] > 0) or (toucher.player.kartstuff[k_wipeoutslow] > 0) then return true end
	mo.state = S_SGSHOTGUNPLAYER
	mo.target = toucher
	
	return true -- <- makes object not disappear
end, MT_SHOTGUN)

addHook("MobjThinker", function(mo)
	if not mo.valid then return end
	
	if leveltime == 1 then
		P_SpawnShadowMobj(mo)
		mo.scale = mapobjectscale*2
	end
	
	if mo.state == S_SGSHOTGUNPLAYER and mo.target then
		local p = mo.target.player
	end

	if mo.state == S_SGSHOTGUNGROUND and mo.target == nil then
		
		if mo.shotgunreset and mo.shotgunreset > 0 then
			mo.shotgunreset = $ - 1
		end
		
		-- Floating height using a sine wave based on leveltime
		local adj = FixedMul(FRACUNIT - cos(mo.angle), (mapobjectscale << 3))
		
		if (mo.eflags & MFE_VERTICALFLIP) then
			mo.z = mo.ceilingz - mo.height - adj
		else
			mo.z = mo.floorz + adj
		end
		-- Rotate smoothly
		mo.angle = $ + ANG1 * 4 -- 4 degrees per tic
		
		mo.flags = (MF_SPECIAL|MF_NOGRAVITY)
	end
	
    if mo.state == S_SGSHOTGUNPLAYER and mo.target then
		
		mo.flags = (MF_SPECIAL|MF_NOCLIP|MF_NOGRAVITY)
		local forwardOffset = mo.target.radius + (20 * FRACUNIT)
		P_MoveOrigin(mo,
			mo.target.x + P_ReturnThrustX(mo.target.player, mo.target.angle, forwardOffset),
			mo.target.y + P_ReturnThrustY(mo.target.player, mo.target.angle, forwardOffset),
			mo.target.z
		)
        mo.angle = mo.target.angle
		mo.momx = mo.target.momx
		mo.momy = mo.target.momy
		mo.momz = mo.target.momz
		
		if not mo.collected then
			S_StartSound(mo, sfx_3db06)
			mo.collected = true
		end
		
		-- Enable the shotgun flag on the player
		if mo.target then
			mo.target.player.hasShotgun = true
		end
		
		local p = mo.target.player
        if (p.kartstuff[k_spinouttimer] > 0) or (p.kartstuff[k_wipeoutslow] > 0) then
			mo.target = nil
			mo.state = S_SGSHOTGUNGROUND
			mo.collected = false
			mo.shotgunreset = 30*TICRATE
			p.hasShotgun = false
		elseif p.deadtimer > 0 then
            mo.target = nil
			mo.state = S_SGSHOTGUNGROUND
			mo.collected = false
			p.hasShotgun = false
			
			-- Instantly return to spawnpoint
			if mo.spawnpoint then
				P_MoveOrigin(mo, mo.spawnpoint.x*FRACUNIT, mo.spawnpoint.y*FRACUNIT, mo.spawnpoint.z*FRACUNIT)
			end
		end
	end
	
	if mo.shotgunreset == 1*TICRATE then
		P_MoveOrigin(mo, mo.spawnpoint.x*FRACUNIT, mo.spawnpoint.y*FRACUNIT, mo.spawnpoint.z*FRACUNIT)
	end
end, MT_SHOTGUN)

addHook("MobjThinker", function(mo)
	if not mo.valid then return end

	-- Keep it moving forward (re-apply thrust)
	P_Thrust(mo, mo.angle, 30 * FRACUNIT)

	-- Check for collision with wall or floor (rudimentary)
	if mo.flags & MF_NOCLIP == 0 and (mo.momx == 0 and mo.momy == 0) then
		P_RemoveMobj(mo)
	end
end, MT_SHOTGUNBULLET)


addHook("PlayerThink", function(p)
	if not p.mo or not p.mo.valid then return end
	if not p.hasShotgun then return end

	p.shotguncooldown = max(($ or 0) - 1, 0)
	
	local cmd = p.cmd

	if (cmd.buttons & BT_ATTACK) and p.shotguncooldown == 0 then
		local centerAngle = p.mo.angle
		local spread = ANG2

		local angles = {
			centerAngle,
			centerAngle - spread,
			centerAngle + spread,
		}

		for _, ang in ipairs(angles) do
			local bullet = P_SpawnMobj(
				p.mo.x + FixedMul(cos(p.mo.angle), 158*FRACUNIT),
				p.mo.y + FixedMul(sin(p.mo.angle), 158*FRACUNIT),
				p.mo.z + p.mo.height / 2,
				MT_SHOTGUNBULLET
			)
			bullet.scale = mapobjectscale*3
			bullet.angle = ang
			P_Thrust(bullet, bullet.angle, 30 * FRACUNIT)
		end
		
		S_StartSound(p.mo, sfx_sgpss)

		p.shotguncooldown = 2*TICRATE
	end
end)

addHook("PlayerSpin", function(p)
	p.hasShotgun = false
	p.shotguncooldown = 0
end)

addHook("MobjDeath", function(p)
	p.hasShotgun = false
	p.shotguncooldown = 0
end, MT_PLAYER)

addHook("PlayerSpawn", function(p)
	p.shotguncooldown = 0
end)